﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Ipc;

namespace csserver
{
	class Program
	{
		static void Main(string[] args)
		{
			//名前つきパイプチャンネルを作成する
			ChannelServices.RegisterChannel(new IpcChannel("IpcRemotingSample"), false);
			//RemoteMessageオブジェクトを公開用に登録する
			RemotingConfiguration.RegisterActivatedServiceType(typeof(RemoteMessage));
			//アプリケーション名を設定する
			RemotingConfiguration.ApplicationName = "RemotingSampleApplication";
			//待機する
			Console.ReadLine();
		}
	}
}
