// drivespace.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include <windows.h>
#include <iostream>

const size_t LOGICAL_DRIVE_STRING_BUFFER = 1024;
const size_t PRIVATE_PROFILE_STRING_BUFFER = 1024;
const size_t DRIVE_COUNT = 26;

//hCûێ
class SearchDriveName
{
public:
	//ۂ̃hCû̃|C^
	LPTSTR lpDriveName_;
	SearchDriveName()
	{
		this->lpDriveName_ = NULL;
	}
	//RXgN^ hCu
	SearchDriveName(LPCTSTR lpDriveName)
	{
		//hCuێĂ
		this->lpDriveName_ = new TCHAR[_tcsnlen(lpDriveName, MAX_PATH) + 1];
		_tcsncpy_s (this->lpDriveName_, sizeof(this->lpDriveName_), lpDriveName, sizeof(lpDriveName));
	}
	~SearchDriveName()
	{
		//hCůJ
		if ( this->lpDriveName_ != NULL )
		{
			delete[] this->lpDriveName_;
		}
	}

};

//AvP[V̐ݒ܂B
class AppSetting
{
public:
	SearchDriveName* DriveList_[DRIVE_COUNT];
	int DriveListIndex;

	//RXgN^
	AppSetting()
	{
		for ( int LoopCounter = 0; LoopCounter < DRIVE_COUNT; LoopCounter++)
		{
			this->DriveList_[LoopCounter] = NULL;
		}
		this->DriveListIndex = 0;
	}
	//fXgN^
	~AppSetting()
	{
		for ( int LoopCounter = 0; LoopCounter < DRIVE_COUNT; LoopCounter++)
		{
			delete this->DriveList_[LoopCounter];
		}
	}
	//init@CAvP[V̏擾܂B
	BOOL Init(LPCTSTR lpFileName)
	{
		//init@C炷ׂẴhCuΏۂɂ邩ǂ̏擾
		TCHAR ProfileBuffer[PRIVATE_PROFILE_STRING_BUFFER + 1];
		DWORD RetVal = ::GetPrivateProfileString( _T("DispDrive"),   _T("AllDrive"),   _T(""),   ProfileBuffer,   PRIVATE_PROFILE_STRING_BUFFER,   lpFileName);
		if ( RetVal > 0 )
		{
			//truȅꍇɂ͎őΏۃhCu񋓂
			if ( _tcscmp(_T("true"), ProfileBuffer) == 0 )
			{
				//ׂĂ̐ڑς݃hCuꗗ擾
				TCHAR buff[LOGICAL_DRIVE_STRING_BUFFER + 1];
				::GetLogicalDriveStrings(LOGICAL_DRIVE_STRING_BUFFER, buff);
				//擾ׂẴhCuSearchDriveNameNXɂĂ
				for ( size_t LoopCounter = 0; LoopCounter < LOGICAL_DRIVE_STRING_BUFFER + 1; )
				{
					if ( buff[LoopCounter] == NULL )
					{
						break;
					}
					//擾hCupXSearchDriveNamegݗĂ
					SearchDriveName* sdn = new SearchDriveName(&buff[LoopCounter]);
					this->DriveList_[this->DriveListIndex++] = sdn;
					LoopCounter += _tcscnlen(buff, LOGICAL_DRIVE_STRING_BUFFER) + 1;
				}
			}
			else
			{
				//falsȅꍇɂDriveNameɏĂ̂ΏۂƂ
				TCHAR* DriveName = new TCHAR[11 + 1];
				for ( int LoopCounter = 0; LoopCounter < DRIVE_COUNT; LoopCounter++)
				{
					_stprintf_s( DriveName, 11 + 1, _T("DriveName%d"), LoopCounter + 1);
					DWORD RetVal = ::GetPrivateProfileString( _T("DispDrive"),   DriveName,   _T(""),   ProfileBuffer,   PRIVATE_PROFILE_STRING_BUFFER,   lpFileName);
					if ( RetVal > 0 )
					{
						//擾hCupXSearchDriveNamegݗĂ
						SearchDriveName* sdn = new SearchDriveName(ProfileBuffer);
						this->DriveList_[this->DriveListIndex++] = sdn;
					}
					else
					{
					}
				}
				delete[] DriveName;

			}
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
};


int _tmain(int argc, _TCHAR* argv[])
{
	//AvP[VǗNX쐬܂B
	AppSetting* setting = new AppSetting();
	//s܂B
	setting->Init( _T("e:\\mypro\\ЃvWFNg\\drivespace\\debug\\drivespace.ini"));

	//{ꕶo͂邽߂ɃP[̐ݒs܂B
	std::wcout.imbue(std::locale("japanese"));
	//ݒ肳Ă鏈ΏۂƂhCüꗗƋ󂫏\B
	for ( int LoopCounter = 0; LoopCounter < setting->DriveListIndex; LoopCounter++)
	{
		ULARGE_INTEGER FreeBytesAvailable ;
		std::wcout << setting->DriveList_[LoopCounter]->lpDriveName_;
		std::wcout << "\t";
		if ( 0 != ::GetDiskFreeSpaceEx(setting->DriveList_[LoopCounter]->lpDriveName_, &FreeBytesAvailable, NULL, NULL))
		{
			std::wcout << FreeBytesAvailable.QuadPart;
		}
		else
		{
			std::wcout << "\t";
		}
		std::wcout << "\n";
		//NEW
	}
	//AvP[VJ܂B
	delete setting;
	return 0;
}

