// oraclr.cpp : C vWFNg t@CłB

#include "stdafx.h"

using namespace System;
using namespace System::Data;
using namespace System::Data::OracleClient;
using namespace System::Data::Common;


int main(array<System::String ^> ^args)
{
	OracleConnection^ con;
	try
	{
		con = gcnew OracleConnection("data source=orcl;user id=system;password=system");
		OracleCommand^ com;
		try
		{
			com = gcnew OracleCommand();
			com->Connection = con;
			com->CommandText = "SELECT * FROM sample";
			try
			{
				con->Open();
				OracleDataReader^ odr;
				try
				{
					odr = com->ExecuteReader();
					while ( odr->Read() )
					{
						System::Console::WriteLine("{0}:{1}", odr["userid"]->ToString(), odr["name"]->ToString() );
					}
				}
				finally
				{
					odr->Close();
				}
			}
			finally
			{
				con->Close();
			}
			
		}
		finally
		{
			delete com;
		}

	}
	finally
	{
		delete con;
	}
	return 0;
}
