using namespace System;
using namespace System::Reflection;
using namespace System::Collections::Generic;

//Ăяos
ref class InvokeAttribute : public Attribute
{
};

//Ώۂ̃NX
[Invoke]
ref class TargetA
{
public:
	[Invoke]
	void MethodA(void)
	{
		Console::WriteLine("TargetA::MethodA");
	}
	void MethodB(void)
	{
		Console::WriteLine("TargetA::MethodA");
	}
};
ref class TargetB
{
public:
	[Invoke]
	void MethodA(void)
	{
		Console::WriteLine("TargetB::MethodA");
	}
};

//ListɓĂMethodInfo̒Invoke̕tĂ̂𔲂o߂Predicate
bool InvokeAttributeMethodPredicate(MethodInfo^ mi)
{
	array<Object^>^ InvokeAttributeList = mi->GetCustomAttributes(InvokeAttribute::typeid, true);
	if ( InvokeAttributeList->Length > 0 )
	{
		return true;
	}
	else
	{
		return false;
	}
}
//ListɓĂObject^̒Invoke̕tĂ̂𔲂o߂Predicate
bool InvokeAttributeInstancePredicate(Object^ obj)
{
	Type^ type = obj->GetType();
	array<Object^>^ InvokeAttributeList = type->GetCustomAttributes(InvokeAttribute::typeid, true);
	if ( InvokeAttributeList->Length > 0 )
	{
		return true;
	}
	else
	{
		return false;
	}
}

//InvoketĂ郁\bĥ݂ĂяoAction
void InvokeAction(Object^ obj)
{
	Type^ type = obj->GetType();
	//pubN\bḧꗗ擾
	array<MethodInfo^>^ methods = type->GetMethods(BindingFlags::Public | BindingFlags::Instance);
	//Invoke̕tĂ郁\bhɍi荞
	array<MethodInfo^>^ FindMethods = methods->FindAll(methods, gcnew Predicate<MethodInfo^>(InvokeAttributeMethodPredicate));
	//c\bh[v
	for each(MethodInfo^ mi in FindMethods)
	{
		//p[^ΌĂяosB
		if ( mi->GetParameters()->Length == 0 )
		{
			mi->Invoke(obj, nullptr);
		}
	}
}

int main()
{
	//
	List<Object^>^ list = gcnew List<Object^>();
	//Ώۃf[^lߍ
	list->Add(gcnew TargetA());
	list->Add(gcnew TargetB());
	list->Add(gcnew TargetA());
	//InvoketĂNXo
	List<Object^>^ TargetInstanceList = list->FindAll(gcnew Predicate<Object^>(InvokeAttributeInstancePredicate));
	//InvoketĂ郁\bhŁAp[^̂Ăяo
	TargetInstanceList->ForEach(gcnew Action<Object^>(InvokeAction));
}
