// drivespace.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include <windows.h>
#include <iostream>
#include <TCHAR.h>

const size_t LOGICAL_DRIVE_STRING_BUFFER = 1024;
const size_t PRIVATE_PROFILE_STRING_BUFFER = 1024;
const size_t DRIVE_COUNT = 26;

//hCûێ
class SearchDriveName
{
public:
	//ۂ̃hCû̃|C^
	LPTSTR lpDriveName_;
	BOOL VolumeLabel_;		//@@Vڂǉ
	SearchDriveName()
	{
		this->lpDriveName_ = NULL;
		this->VolumeLabel_ = FALSE;	//@@Vڂ̏
	}
	//RXgN^ hCu
	SearchDriveName(LPCTSTR lpDriveName)
	{
		//hCuێĂ
		this->lpDriveName_ = new TCHAR[_tcsnlen(lpDriveName, MAX_PATH) + 1];
		_tcsncpy_s (this->lpDriveName_, sizeof(this->lpDriveName_), lpDriveName, sizeof(lpDriveName));
		this->VolumeLabel_ = FALSE;	//@@Vڂ̏
	}
	~SearchDriveName()
	{
		//hCủ
		if ( this->lpDriveName_ != NULL )
		{
			delete[] this->lpDriveName_;
		}
	}

};

//AvP[V̐ݒ
class AppSetting
{
public:
	SearchDriveName* DriveList_[DRIVE_COUNT];
	int DriveListIndex;

	//RXgN^
	AppSetting()
	{
		for ( int LoopCounter = 0; LoopCounter < DRIVE_COUNT; LoopCounter++)
		{
			this->DriveList_[LoopCounter] = NULL;
		}
		this->DriveListIndex = 0;
	}
	//fXgN^
	~AppSetting()
	{
		for ( int LoopCounter = 0; LoopCounter < DRIVE_COUNT; LoopCounter++)
		{
			delete this->DriveList_[LoopCounter];
		}
	}
	//init@CAvP[V̏擾
	BOOL Init(LPCTSTR lpFileName)
	{
		//XMLǂݍ
		System::Xml::XmlDocument xd;
		xd.Load(gcnew System::String(lpFileName));
		///ROOT/DispDriveǂ݂AllDirivesǂ̔s
		System::Xml::XmlNode^ node = xd.SelectSingleNode("/ROOT/DispDrive");
		if ( node->Attributes["AllDrive"]->Value == "true" )
		{
			//@@@\̂܂
			//ׂĂ̐ڑς݃hCuꗗ擾
			TCHAR buff[LOGICAL_DRIVE_STRING_BUFFER + 1];
			::GetLogicalDriveStrings(LOGICAL_DRIVE_STRING_BUFFER, buff);
			//擾ׂẴhCu
			//SearchDriveNameNXɂĂ
			for ( size_t LoopCounter = 0; LoopCounter < LOGICAL_DRIVE_STRING_BUFFER + 1; )
			{
				if ( buff[LoopCounter] == NULL )
				{
					break;
				}
				//擾hCupXƂSearchDriveName
				//gݗĂ
				SearchDriveName* sdn = new SearchDriveName(&buff[LoopCounter]);
				this->DriveList_[this->DriveListIndex++] = sdn;
				LoopCounter += _tcscnlen(buff, LOGICAL_DRIVE_STRING_BUFFER) + 1;
			}
			//@@@\̂܂
		}
		else
		{
			//XMLhCu𔲂
			System::Xml::XmlNodeList ^ nodelist = xd.SelectNodes("/ROOT/DispDrive/DriveName");
			//hCû邾JԂ
			for each ( System::Xml::XmlNode^ Target in nodelist)
			{
				//擾hCupXƂSearchDriveNamegݗĂ
				System::IntPtr ValueStringPtr = System::Runtime::InteropServices::Marshal::StringToHGlobalAuto(Target->InnerText);
				SearchDriveName* sdn = new SearchDriveName(static_cast<LPCTSTR>(ValueStringPtr.ToPointer()));
				System::Runtime::InteropServices::Marshal::FreeHGlobal(ValueStringPtr);
				//{[x擾邩ǂ̑𔻒f
				if ( Target->Attributes["VolumeLabel"] != nullptr )
				{
					sdn->VolumeLabel_ = Target->Attributes["VolumeLabel"]->Value == "true" ? TRUE : FALSE;
				}
				this->DriveList_[this->DriveListIndex++] = sdn;
	
			}
	
		}
		return TRUE;
	}
};


int _tmain(int argc, _TCHAR* argv[])
{
	//AvP[VǗNX쐬܂B
	AppSetting* setting = new AppSetting();
	//s
	setting->Init( _T("drivespace.xml"));

	//{ꕶo͂邽߂ɃP[̐ݒs
	std::wcout.imbue(std::locale("japanese"));
	//ݒ肳Ă鏈ΏۂƂhCüꗗ\
	for ( int LoopCounter = 0; LoopCounter < setting->DriveListIndex; LoopCounter++)
	{
		ULARGE_INTEGER FreeBytesAvailable ;
		std::wcout << setting->DriveList_[LoopCounter]->lpDriveName_;
		std::wcout << "\t";
		if ( 0 != ::GetDiskFreeSpaceEx(setting->DriveList_[LoopCounter]->lpDriveName_, &FreeBytesAvailable, NULL, NULL))
		{
			std::wcout << FreeBytesAvailable.QuadPart;
		}
		else
		{
			std::wcout << "\t";
		}
		std::wcout << "\t";

		//{[x擾
		if ( setting->DriveList_[LoopCounter]->VolumeLabel_ == TRUE )
		{
			TCHAR VolumeNameBuffer[sizeof(TCHAR) * (1024+1)];
			DWORD VolumeSerialNumber;
			DWORD MaximumComponentLength;
			DWORD FileSystemFlags;

			VolumeNameBuffer[0] = _T('\0');

			::GetVolumeInformation(setting->DriveList_[LoopCounter]->lpDriveName_, VolumeNameBuffer, sizeof(VolumeNameBuffer) / sizeof(VolumeNameBuffer[0]),
				&VolumeSerialNumber, &MaximumComponentLength, &FileSystemFlags, NULL, 0 );
			std::wcout << VolumeNameBuffer;
		}
		else
		{
			std::wcout << "\t";
		}
		std::wcout << "\n";
	}
	//AvP[V
	delete setting;
	return 0;
}

